"""
Point2Play Source Code
Copyright 2003, 2004 TransGaming Technologies Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.

"""

try:
    import pygtk
    pygtk.require('2.0')
except:
    pass

try:
    import gtk, gobject
except:
    raise config_guiError( _("Unable to load GTK2 Python bindings") )

import types, config, copy, os.path, Point2Play

class config_guiError( Exception ):
    def __init__( self, message ):
        self.message = message

    def __str__( self ):
        return `self.message`


# Types of configuration options
CHECK           = 1
COMBO           = 2
COMBO_EDITABLE  = 3
COMBO_HASHED    = 4
STRING          = 5
BUTTON          = 6
COMBO_WINEXVER  = 7
BUTTON_JOYSTICK = 8
COMBO_SOUND     = 9


# Whether the option is ALSA only, OSS only, or non-applicable
SOUND_NA        = 0
SOUND_OSSONLY   = 1
SOUND_ALSAONLY  = 2

# FIXME - the below game option widgets have been rendered obsolete by
# the options_gui glade code. Should be removed at some point.

desktops = ( "No", "640x480", "800x600", "1024x768", "1280x1024", "1600x1200" )

winvers  = ( "win95", "win98", "winme", "nt351", "nt40", "win2k", "winxp" )

sounddrivers_hashed = ( { "internal" : "wineoss.drv", 
                          "display"  : "OSS"
                        },
                        { "internal" : "winealsa.drv",
                          "display"  : "ALSA"
                        }
                      )

pixelshader_versions = ("1.1", "1.2", "1.3" )

auto_y_n_hashed =  ( 
                     { "internal" : "Auto",
                       "display"  : "Auto"
                     }, 
                     { "internal" : "yes",
                       "display"  : "Yes"
                     },
                     {
                      "internal"  : "no",
                      "display"   : "No"
                     }
                   )

vertexshadermode_options = ( "Auto", "Hardware", "Software" )

def _get_options( game_config, executable, options ):
    _options = None
    for i in options:
        if (i["option"] == "y"):
           val = game_config.get_option( i["section"], i["name"], executable, 1 )
        else:
           # Assume we want a section rather than just an option
           # 
           # This is a bit specific to joysticks (the name and details part)
           # but can of course be more generalized if we ever start to support
           # other section based configurations (multiple entries for the same 
           # category basically)
           js_sec = game_config.get_section(i["name"], executable)
           if (js_sec):
              val = []
              for js in js_sec["options"]:
                 val.append( { "name": js["name"], "details": js["value"] } )
           else:
              val = None

        if not val:
            val = i["default"]

        if _options:
            _options[i["section"] + ":" + i["name"]] = val
        else:
            _options = { i["section"] + ":" + i["name"]: val }

    return _options
