"""
Point2Play Source Code
Copyright (c) 2005 by TransGaming Technologies, Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.

"""

# This module defines a simple class to keep track of a list of error strings. 
# It's used in p2p_gui.py for the one-shot updater.
# I couldn't use a module-scope string variable for this since every time you say
#   mystring = mystring + "Next error message\n"
# it's actually creating an entirely new variable with new memory allocated
# (pretty inefficient!) and this new variable has local scope, too, so we run into 
# difficulties.

import string

class ErrorString:
    def __init__(self):
        self.clear()

    def add_error(self, another_errormsg):
        self.error_string.append(another_errormsg)

    def stringify(self):
        return string.join(self.error_string, ('\n'))

    def clear(self):
        self.error_string = []
        