#!/usr/bin/env python

"""
Point2Play Source Code
Copyright (c) 2005 by TransGaming Technologies, Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written
permission of TransGaming Technologies Inc.

"""
import pygtk
pygtk.require('2.0')
import gtk
import gtk.glade
import log, copy
import os
from types import *
import gobject
import p2p_diag
import  p2p_gui
import cedega_version_parse
import ConfigParser

p2ppath = os.getenv("P2PPATH")
GLADE_FILE = p2ppath + "/gui/" + __name__ + ".glade"

class WidgetsWrapper:
    def __init__(self):
        self.widgets = gtk.glade.XML(GLADE_FILE, None, "p2p_localized_msg")

    # Gives us the ability to do: widgets['widget_name'].action()
    def __getitem__(self, key):
        return self.widgets.get_widget(key)

class ManualCedegaInstallDialog:
    def __init__(self, Point2Play, parent):
        self.Point2Play = Point2Play
        self.parent = parent
        self.widgets = WidgetsWrapper()
        self.widgets["path_to_file"].connect( 'changed', self.sensitive_cb)
        self.widgets.widgets.signal_autoconnect(self)
        self.widgets["ok_button"].set_sensitive(0)
        self.Point2Play_gui = parent

    def sensitive_cb(self, button ):
        """ Make sure the filename ends in the extension cpkg."""
        the_text = self.widgets["path_to_file"].get_text();
        if len(the_text) > 0 and the_text[-5:] == ".cpkg":
            self.widgets["ok_button"].set_sensitive(1)
        else:
            self.widgets["ok_button"].set_sensitive(0)

    def get_filename(self):
        return self.widgets["path_to_file"].get_text()

    def browse_files_cb(self, button):
	""" Pop up a file selection dialog for the installer. """
        self.filesel = gtk.FileChooserDialog(_("Select Local Update"))
        self.filesel.set_transient_for(self.widgets["install"])
        self.filesel.connect("response", self.filesel_response_cb)
        self.filesel.add_button(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL)
        self.filesel.add_button(gtk.STOCK_OK,gtk.RESPONSE_OK)
        #self.filesel.hide_fileop_buttons()
        self.filesel.set_resizable(1)

        # Ok, let's see if the user entered a path to browse...
        filename = self.widgets["path_to_file"].get_text()
        if not len( filename ):
            # The user has entered nothing, so we'll default to HOME...
            filename = os.environ["HOME"] + "/"

        self.filesel.set_current_folder(filename)
        try:
            self.filesel.add_shortcut_folder(self.Point2Play.P2PFOLDER)
        except:
            pass

        filter1 = gtk.FileFilter()
        filter1.add_pattern("*.cpkg")
        filter1.set_name("Cedega Engine Files")
        self.filesel.add_filter(filter1)

        filter2 = gtk.FileFilter()
        filter2.add_pattern("*")
        filter2.set_name("All Files")
        self.filesel.add_filter(filter2)
        self.filesel.run()

        # remove .cedega from the shortcuts list before we destroy 
        # the file chooser - this is system-wide!
        try:
            self.filesel.remove_shortcut_folder(self.Point2Play.P2PFOLDER)
        except:
            pass
        self.filesel.destroy()


    def filesel_response_cb(self, filesel, response):
        """ Put the fileselection popup data in the right place """
        if response==gtk.RESPONSE_OK:
            self.widgets["path_to_file"].set_text(self.filesel.get_filename())


    def manual_install_ok_cb( self, button ):
        self.widgets["manual_cedega_install"].response(1)


    def manual_install_cancel_cb( self, button ):
        self.widgets["manual_cedega_install"].response(0)


    def run( self ):
        while 1:
            resp = gtk.Dialog.run( self.widgets["manual_cedega_install"] )
            if resp == 1:
                try:
                    filename = self.get_filename()
                except:
                    print _("There were problems accessing the file")
            else:
                filename = None

            # Whether the user hit ok, or cancel, return our filename...
            return filename
