"""
Point2Play Source Code
Copyright 2003, TransGaming Technologies Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.

"""

try:
    import pygtk
    pygtk.require('2.0')
except:
    pass

import gtk, gobject, config

options = [ [ _("Advanced Options"), [ _("Configure Drives"), _("Configure Ports"), _("Configure Fonts") ] ] ]

class PreferencesDialog( gtk.Dialog ):
    def __init__( self, P2P, game ):
        gtk.Dialog.__init__(self)
        self.set_title( _("Preferences") )
        self.set_size_request( 400, 300 )
        self.selected_option = None
        option_model = gtk.TreeStore( gobject.TYPE_STRING )
        for top_option in options:
            top_iter = option_model.append( None )
            option_model.set_value( top_iter, 0, top_option[0] )
            for sub_option in top_option[1]:
                iter = option_model.append( top_iter )
                option_model.set_value( iter, 0, sub_option )
        self.widgets = { "option_tree": gtk.TreeView( option_model ) }
        cell = gtk.CellRendererText()
        col = gtk.TreeViewColumn( _("Program"), cell, text=0 )
        self.widgets["option_tree"].append_column( col )
        hbox = gtk.HBox()
        sw = gtk.ScrolledWindow()
        sw.set_size_request( 180, 300 )
        sw.add( self.widgets["option_tree"] )
        hbox.pack_start( sw, gtk.FALSE, gtk.FALSE )
        vbox = self.get_children()[0]
        vbox.pack_start( hbox, gtk.FALSE, gtk.FALSE )
        self.widgets["option_tree"].get_selection().set_mode('single')
        self.widgets["option_tree"].get_selection().connect( 'changed', self.select_option_cb )
        self.add_button( gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE )
        self.show_all()
        for top_option in options:
            for sub_option in top_option[1]:
                self.widgets[sub_option] = gtk.Frame( sub_option )
                hbox.add( self.widgets[sub_option] )

    def select_option_cb( self, selection, *args ):
        sel = selection.get_selected()
        if sel:
            model, iter = sel
            if self.selected_option:
                self.selected_option.hide()
                self.selected_option = None
            if iter:
                option_name = model.get_value( iter, 0 )
                for top_option in options:
                    for sub_option in top_option[1]:
                        if sub_option == option_name:
                            self.widgets[option_name].show()
                            self.selected_option = self.widgets[option_name]

if __name__ == '__main__':
    a = PreferencesDialog(None, None)
    a.run()
    a.destroy()
