#!/usr/bin/python

"""
Point2Play Source Code
Copyright 2005, TransGaming Technologies Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.

"""

import os, Point2Play
import system_detection

TESTS = (_("Test For OpenGL Direct Rendering"), "tgtest_gl", False),

def tgtest_gl():
    """runs tests to ensure that OpenGL Direct Rendering is supported"""

    # Call system_detection function to determine if direct rendering is supported
    # on this machine.
    direct = system_detection.detect_opengl_direct_rendering()
    if direct.upper() == "YES":
        result_color = 'green'
        result_text = "Supported"
    else:
        result_color = 'red'
        result_text = "Not Supported"

    result = (_('OpenGL Direct Rendering'), result_text, result_color),
    return result


if (__name__ == "__main__"):
    for test in TESTS:
        print "running test ", test[0]
        eval(test[1] + '()')

