#!/usr/bin/env python

"""
Point2Play Source Code
Copyright (c) 2005 by TransGaming Technologies, Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.

"""

import pygtk
pygtk.require('2.0')
import gtk
import gtk.glade
from types import *
import os, log, p2p_gui


p2ppath = os.getenv("P2PPATH")
GLADE_FILE = p2ppath + "/gui/" + __name__ + ".glade"
LICENSE = p2ppath + "/LICENSE"
	
class WidgetsWrapper:
    def __init__(self):
        self.widgets = gtk.glade.XML(GLADE_FILE, None, "p2p_localized_msg")

    # Gives us the ability to do: widgets['widget_name'].action()
    def __getitem__(self, key):
        return self.widgets.get_widget(key)

class UpdateChecker:
    def __init__(self, needs_updating_list):
        self.widgets = WidgetsWrapper()
        self.widgets.widgets.signal_autoconnect(self)

        # list active/inactive for the checkbuttons in this order:
        # MSCOREFONTS , MOZCONTROL , CEDEGA , P2P , GDDB 

        self.widgets["mscorefonts_checkbutton"].set_active(needs_updating_list[p2p_gui.MSCOREFONTS])
        self.widgets["mozcontrol_checkbutton"].set_active(needs_updating_list[p2p_gui.MOZCONTROL])
        self.widgets["cedega_checkbutton"].set_active(needs_updating_list[p2p_gui.CEDEGA])
        self.widgets["p2p_checkbutton"].set_active(needs_updating_list[p2p_gui.P2P])
        self.widgets["gddb_checkbutton"].set_active(needs_updating_list[p2p_gui.GDDB])
       
        self.checkbuttons = []  

        if tuple(needs_updating_list) == (0,0,0,0,0):
            # nothing requires updating
            self.widgets["update_information_label"].set_text(_("Your packages are up-to-date."))
        else:
            self.widgets["update_information_label"].set_text(_("Updates found. Click OK to update."))
            if tuple(needs_updating_list) == (1,1,1,1):
                self.widgets["force_update_label"].set_text("")
    
        self.widgets["ok_button"].grab_focus()

    def ok_cb(self, button):
        """ See what the user has done with the checkboxes and store the on/offness in
            the self.checkbuttons list."""

        self.save_data()
        self.widgets["update_checker"].response(1)

    def cancel_cb(self, button):
        self.save_data()
        self.widgets["update_checker"].response(0)

    def save_data(self):
        self.checkbuttons.append( self.widgets["mscorefonts_checkbutton"].get_active() )
        self.checkbuttons.append( self.widgets["mozcontrol_checkbutton"].get_active() )
        self.checkbuttons.append( self.widgets["cedega_checkbutton"].get_active() )
        self.checkbuttons.append( self.widgets["p2p_checkbutton"].get_active() )
        self.checkbuttons.append( self.widgets["gddb_checkbutton"].get_active() )
