"""
Point2Play Source Code
Copyright 2003, TransGaming Technologies Inc.
All rights reserved
Redistribution of Point2Play is forbidden without the expressed written 
permission of TransGaming Technologies Inc.

"""

import ClientCookie, urllib

LOGINURL="http://www.transgaming.com/loginuser.php"
VERSION_URL="http://www.transgaming.com/versions.php"

LOGIN_OK=0
LOGIN_FAILED=-1
CONNECT_FAILED=-2

def utf2html(utfstring):
    """ Takes a string containing utf characters and converts characters with
        common diacritics to HTML character entities. This is used for converting
        usernames with umlauts, accents, etc., to a format that the website expects, 
        for example, "&ouml;" for o-umlaut rather than the two-character 
        ascii interpretation that it would otherwise receive (A-tilde followed by a
        paragraph symbol). Note that passing username.encode("iso-8859-1") in
        the urlopen line below does not work. """

    # this is just a bunch of replacing.
    utfstring = utfstring.replace(unichr(192), '&Agrave;')
    utfstring = utfstring.replace(unichr(193), '&Aacute;')
    utfstring = utfstring.replace(unichr(194), '&Acirc;')
    utfstring = utfstring.replace(unichr(195), '&Atilde;')
    utfstring = utfstring.replace(unichr(196), '&Auml;')
    utfstring = utfstring.replace(unichr(197), '&Aring;')
    utfstring = utfstring.replace(unichr(198), '&AElig;')
    utfstring = utfstring.replace(unichr(199), '&Ccedil;')
    utfstring = utfstring.replace(unichr(200), '&Egrave;')
    utfstring = utfstring.replace(unichr(201), '&Eacute;')
    utfstring = utfstring.replace(unichr(202), '&Ecirc;')
    utfstring = utfstring.replace(unichr(203), '&Euml;')
    utfstring = utfstring.replace(unichr(204), '&Igrave;')
    utfstring = utfstring.replace(unichr(205), '&Iacute;')
    utfstring = utfstring.replace(unichr(206), '&Icirc;')
    utfstring = utfstring.replace(unichr(207), '&Iuml;')
    utfstring = utfstring.replace(unichr(208), '&ETH;')
    utfstring = utfstring.replace(unichr(209), '&Ntilde;')
    utfstring = utfstring.replace(unichr(210), '&Ograve;')
    utfstring = utfstring.replace(unichr(211), '&Oacute;')
    utfstring = utfstring.replace(unichr(212), '&Ocirc;')
    utfstring = utfstring.replace(unichr(213), '&Otilde;')
    utfstring = utfstring.replace(unichr(214), '&Ouml;')
# 215 is 'x' - a placeholder perhaps?
    utfstring = utfstring.replace(unichr(216), '&Oslash;')
    utfstring = utfstring.replace(unichr(217), '&Ugrave;')
    utfstring = utfstring.replace(unichr(218), '&Uacute;')
    utfstring = utfstring.replace(unichr(219), '&Ucirc;')
    utfstring = utfstring.replace(unichr(220), '&Uuml;')
    utfstring = utfstring.replace(unichr(221), '&Yacute;')
    utfstring = utfstring.replace(unichr(222), '&THORN;')
    utfstring = utfstring.replace(unichr(223), '&szlig;')
    utfstring = utfstring.replace(unichr(224), '&agrave;')
    utfstring = utfstring.replace(unichr(225), '&aacute;')
    utfstring = utfstring.replace(unichr(226), '&acirc;')
    utfstring = utfstring.replace(unichr(227), '&atilde;')
    utfstring = utfstring.replace(unichr(228), '&auml;')
    utfstring = utfstring.replace(unichr(229), '&aring;')
    utfstring = utfstring.replace(unichr(230), '&aelig;')
    utfstring = utfstring.replace(unichr(231), '&ccedil;')
    utfstring = utfstring.replace(unichr(232), '&egrave;')
    utfstring = utfstring.replace(unichr(233), '&eacute;')
    utfstring = utfstring.replace(unichr(234), '&ecirc;')
    utfstring = utfstring.replace(unichr(235), '&euml;')
    utfstring = utfstring.replace(unichr(236), '&igrave;')
    utfstring = utfstring.replace(unichr(237), '&iacute;')
    utfstring = utfstring.replace(unichr(238), '&icirc;')
    utfstring = utfstring.replace(unichr(239), '&iuml;')
    utfstring = utfstring.replace(unichr(240), '&eth;')
    utfstring = utfstring.replace(unichr(241), '&ntilde;')
    utfstring = utfstring.replace(unichr(242), '&ograve;')
    utfstring = utfstring.replace(unichr(243), '&oacute;')
    utfstring = utfstring.replace(unichr(244), '&ocirc;')
    utfstring = utfstring.replace(unichr(245), '&otilde;')
    utfstring = utfstring.replace(unichr(246), '&ouml;')
# 247 is a division sign
    utfstring = utfstring.replace(unichr(248), '&oslash;')
    utfstring = utfstring.replace(unichr(249), '&ugrave;')
    utfstring = utfstring.replace(unichr(250), '&uacute;')
    utfstring = utfstring.replace(unichr(251), '&ucirc;')
    utfstring = utfstring.replace(unichr(252), '&uuml;')
    utfstring = utfstring.replace(unichr(253), '&yacute;')
    utfstring = utfstring.replace(unichr(254), '&thorn;')
    utfstring = utfstring.replace(unichr(255), '&yuml;')
    return utfstring

class winexGetError(Exception):
    def __init__(self, message):
        self.message = message

    def __str__(self):
        return self.message

def login_transgaming( username, password ):
    # If these fields are not full, don't show the error message below...
    if not username and not password:
        return

    fp = ClientCookie.urlopen( LOGINURL, urllib.urlencode( { "fuser_name": utf2html(username), "fpassword": password } ) )

    for line in fp.readlines():
        if line.find( "Login Failed!" ) != -1:
            raise winexGetError(_("Sorry, your login attempt failed.  Please check your user name and password.  If you continue to have difficulties please contact support@transgaming.com."))
        if line.find( "Pay Subscription Fees") != -1:
            raise winexGetError(_("Sorry, your subscription has expired. Please log in at http://www.transgaming.com/ to extend it."))

def winex_versions():
    fp = ClientCookie.urlopen(VERSION_URL)
    versions = []
    for line in fp.readlines():
        (ver, bin_lic, bin, doc_lic, doc ) = line.strip().split(",")
        versions.append( { "version": ver, "binary_license": bin_lic, "binary": bin, "documentation_license": doc_lic, "documentation": doc } )
    return versions

def winex_get( version_list, version ):
    for ver in version_list:
        if ver["version"] == version:
            fp = ClientCookie.urlopen( ver["binary"] )
            return fp
    return None

def winex_get_license( P2P, version_list, version ):
    for ver in version_list:
        if ver["version"] == version:
            if len( ver["binary_license"] ):
                return ClientCookie.urlopen( ver["binary_license"] )
    return None
